Foreman - Bug #26414

Api error when querying LDAP users
03/20/2019 09:32 AM - Ondfej Prazak

Status: New
Priority: Normal
Assignee:

Category:

Target version:

Difficulty: Fixed in Releases:
Triaged: No Found in Releases:
Bugzilla link: 1620164 Red Hat JIRA:

Pull request:

Description

Description of problem:
We get RuntimeError when we try to list LDAP users.

Steps to reproduce:
hammer user list --auth-source-ldap-id 3

2019-03-20T09:22:04 [I|appl|9efal0498] Started GET "/api/auth_source_ldaps/3/users?page=1l&per_page=1
000" for ::1 at 2019-03-20 09:22:04 +0000
2019-03-20T09:22:04 [I|appl9efa0498] Processing by Api::V2::UsersController#index as JSON
2019-03-20T09:22:04 [I|appl9%efa0498] Parameters: {"page"=>"1", "per_page"=>"1000", "apiv"=>"v2",
"auth_source_ldap_id"=>"3", "user"=>{}}
2019-03-20T09:22:04 [D|appl9efa0498] Authenticated user admin against INTERNAL authentication sour
ce
2019-03-20T09:22:04 [D|appl9efa0498] Current user set to foreman_admin (admin)
2019-03-20T09:22:04 [I|appl9%efa0498] Authorized user admin (Admin User)
2019-03-20T09:22:04 [I|appl9efa0498] Current user set to admin (admin)
2019-03-20T09:22:04 [D|appl9efa0498] Current location set to none
2019-03-20T09:22:04 [D|appl9efa0498] Current organization set to none
2019-03-20T09:22:04 [D|appl9efa0498] Current location set to none
2019-03-20T09:22:04 [Dl|appl9efa0498] Current organization set to none
2019-03-20T09:22:04 [W|app|9efa0498] DEPRECATION WARNING: Dangerous query method (method whose arg
uments are used as raw SQL) called with non-attribute argument (s): "CASE WHEN \"auth_sources\".\"n
ame\" = '3' THEN 1 ELSE 0 END". Non-attribute arguments will be disallowed in Rails 6.0. This meth
od should not be called with user-provided values, such as request parameters or model attributes.
Known-safe values can be passed by wrapping them in Arel.sgl (). (called from prioritize_friendly_
name_records at /home/vagrant/projects/foreman/app/controllers/api/base_controller.rb:410)
2019-03-20T09:22:04 [W|app|9efa0498] DEPRECATION WARNING: Dangerous query method (method whose arg
uments are used as raw SQL) called with non-attribute argument (s): "CASE WHEN \"auth_sources\".\"n
ame\" = '3' THEN 1 ELSE 0 END". Non-attribute arguments will be disallowed in Rails 6.0. This meth
od should not be called with user-provided values, such as request parameters or model attributes.
Known-safe values can be passed by wrapping them in Arel.sqgl (). (called from prioritize_friendly_
name_records at /home/vagrant/projects/foreman/app/controllers/api/base_controller.rb:410)
2019-03-20T09:22:04 [W|app|9efa0498] Action failed

| RuntimeError: Association not found for auth_source_ldap

| /home/vagrant/projects/foreman/app/controllers/api/base_controller.rb:75:in “parent_scope'

| /home/vagrant/projects/foreman/app/controllers/api/base_controller.rb:61:in 'resource_scope'

| /home/vagrant/projects/foreman/app/controllers/concerns/foreman/controller/users_mixin.rb:10:1in
‘resource_scope'

| /home/vagrant/projects/foreman/app/controllers/api/base_controller.rb:100:in "resource_scope_fo
r_index'

| /home/vagrant/projects/foreman/app/controllers/api/v2/users_controller.rb:31:in "index'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1lib/action_controller/metal/basic_impl
icit_render.rb:6:1in “send_action'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/abstract_controller/base.rb:194:in
‘process_action'
| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_controller/metal/rendering.
rb:30:in "process_action'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/abstract_controller/callbacks.rb:4
2:in "block in process_action'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/callbacks.rb:109
:in “block in run_callbacks'

| /home/vagrant/projects/foreman/app/controllers/api/v2/base_controller.rb:163:in ‘disable_json_r
oot

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/callbacks.rb:118
:in “block in run_callbacks'

| /home/vagrant/projects/foreman/app/controllers/concerns/foreman/controller/timezone.rb:10:in s
et_timezone'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/callbacks.rb:118
:in “block in run_callbacks'

| /home/vagrant/projects/foreman/app/models/concerns/foreman/thread_session.rb:32:in ‘clear_threa
dl

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/callbacks.rb:118
:in “block in run_callbacks'

| /home/vagrant/projects/foreman/app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12
:in 'set_topbar_sweeper_controller'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/callbacks.rb:118
:in “block in run_callbacks'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/audited-4.8.0/1lib/audited/sweeper.rb:14:in "“around'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/callbacks.rb:118
:in “block in run_callbacks'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/audited-4.8.0/1ib/audited/sweeper.rb:14:in "“around'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1lib/active_support/callbacks.rb:118
:in “block in run_callbacks'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/callbacks.rb:136
:in “run_callbacks'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/abstract_controller/callbacks.rb:4
l:in "process_action'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_controller/metal/rescue.rb:
22:in “process_action'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1lib/action_controller/metal/instrument
ation.rb:34:in “block in process_action'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/notifications.rb
:168:in "block in instrument'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/notifications/in
strumenter.rb:23:in "~ instrument'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/notifications.rb
:168:in "~ instrument'’

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1lib/action_controller/metal/instrument
ation.rb:32:in “process_action'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1lib/action_controller/metal/params_wra
pper.rb:256:in “process_action'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/activerecord-5.2.1/1ib/active_record/railties/controlle
r_runtime.rb:24:in “process_action'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/abstract_controller/base.rb:134:1in

‘process'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionview-5.2.1/1lib/action_view/rendering.rb:32:in "pr
ocess'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_controller/metal.rb:191:in
“dispatch'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_controller/metal.rb:252:in
“dispatch'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/routing/route_set.
rb:52:in “dispatch'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/routing/route_set.
rb:34:in " serve'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/routing/mapper.rb:
18:in "block in <class:Constraints>'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/routing/mapper.rb:
48:in " serve'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/journey/router.rb:
52:in "block in serve'

| /home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/journey/router.rb:
/home/vagrant/.

in “serve'

/home/vagrant/.

840:in ‘call'’

/home/vagrant/.

127:in “call’

/home/vagrant/ .

127:in “call'

/home/vagrant/.

‘call!

/home/vagrant/.
/home/vagrant/.

in ‘call"'

rvm/gems/ruby—2.
rvm/gems/ruby-2.
rvm/gems/ruby—2.

rvm/gems/ruby—-2.
rvm/gems/ruby-2.

.4/gems/actionpack-5.2.
1/lib/action_dispatch/routing/route_set.
1/1lib/action_dispatch/middleware/static.

1/1lib/action_dispatch/middleware/static.

.4/gems/apipie-rails-0.5.15/1ib/apipie/static_dispatcher.rb:66:

.4/gems/bullet-5.9.0/1lib/bullet/rack.rb:15:in “call’
.4/gems/apipie-rails-0.5.15/1ib/apipie/extractor/recorder.rb:13

/home/vagrant /projects/foreman/lib/foreman/middleware/telemetry.rb:10:in “call’
/home/vagrant/.rvm/gems/ruby-2.3.4/gems/apipie-rails-0.5.15/1ib/apipie/middleware/checksum_in_h

‘call'

/home/vagrant /projects/foreman/lib/foreman/middleware/catch_json_parse_errors.rb:9:in ‘call'

/home/vagrant/.
r.rb:14:in “call'

| /home/vagrant/.
.4/gems/rack-2.0.6/1lib/rack/tempfile_reaper.rb:15:in “call’
.4/gems/rack-2.0.6/1lib/rack/etag.rb:25:in “call’
.4/gems/rack-2.0.6/1lib/rack/conditional_get.rb:25:in ‘call'
.4/gems/rack-2.0.6/1ib/rack/head.rb:12:in “call'
.4/gems/actionpack-5.2.1/1ib/action_dispatch/http/content_secur
4/gems/rack-openid-1.4.2/1ib/rack/openid.rb:98:in ‘call'

/home/vagrant /projects/foreman/lib/foreman/middleware/logging_context_session.rb:22:in “call'
/home/vagrant/.rvm/gems/ruby-2.3.4/gems/rack-2.0.6/1ib/rack/session/abstract/id.rb:232:in cont
ext'

/home/vagrant/.

/home/vagrant/ .
rvm/gems/ruby-2.

‘call'

rvm/gems/ruby-2.

rvm/gems/ruby-2.
rvm/gems/ruby—2.

.4/gems/actionpack-5.2.
.4/gems/actionpack-5.2.
.4/gems/actionpack-5.2.

.4/gems/actionpack-5.2.

.4/gems/rack-2.0.6/1lib/rack/session/abstract/id.rb:226:in ‘call
.4/gems/actionpack-5.2.1/1ib/action_dispatch/middleware/cookies
.4/gems/activerecord-5.2.1/1ib/active_record/migration.rb:559:1
.4/gems/actionpack-5.2.1/1lib/action_dispatch/middleware/callbac

.4/gems/activesupport-5.2.1/1lib/active_support/callbacks.rb:98:

1/1lib/action_dispatch/middleware/callbac
1/1lib/action_dispatch/middleware/executo
1/lib/action_dispatch/middleware/debug_e

1/1lib/action_dispatch/middleware/show_ex

.4/gems/railties-5.2.1/1ib/rails/rack/logger.rb:38:in "call_app

.4/gems/railties-5.2.1/1ib/rails/rack/logger.rb:28:in “call'
.4/gems/sprockets-rails-3.2.1/1ib/sprockets/rails/quiet_assets.

/home/vagrant/projects/foreman/lib/foreman/middleware/logging_context_request.rb:11:in “call'
/home/vagrant/.rvm/gems/ruby—-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/middleware/remote_

.rb:81:1in

‘call'

/home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/middleware/request

‘call'

/home/vagrant /projects/katello/lib/katello/prevent_json_parsing.rb:12:in “call’
/home/vagrant/.rvm/gems/ruby-2.3.4/gems/rack-2.0.6/1lib/rack/method_override.rb:22:in “call’
/home/vagrant/.rvm/gems/ruby-2.3.4/gems/rack-2.0.6/1lib/rack/runtime.rb:22:in “call'
/home/vagrant/.rvm/gems/ruby-2.3.4/gems/activesupport-5.2.1/1ib/active_support/cache/strategy/1

‘call'

/home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/middleware/executo

‘call'

/home/vagrant/.rvm/gems/ruby-2.3.4/gems/actionpack-5.2.1/1ib/action_dispatch/middleware/static.

:127:in “call’

/home/vagrant/.rvm/gems/ruby-2.3.4/gems/rack-2.0.6/1ib/rack/sendfile.rb:111:in “call'
/home/vagrant/.rvm/gems/ruby-2.3.4/gems/secure_headers-6.0.0/1ib/secure_headers/middleware.rb:1
in “block in call'
.0/lib/puma/server.rb:658:in "handle_request'
.0/1lib/puma/server.rb:472:in “process_client'
0/lib/puma/server.rb:332:in “block in run'
.0/1lib/puma/thread_pool.rb:133:in ‘block in sp

History

#1 - 04/28/2019 08:32 PM - Anonymous

- Related to Refactor #23300: Do not use string interpolation when composing SQL queries. added

#2 - 04/28/2019 08:32 PM - Anonymous
- Blocks Tracker #24837: Rails 6.0 Tracker added

#3 - 11/12/2019 01:16 PM - Anonymous
- Blocks deleted (Tracker #24837: Rails 6.0 Tracker)

#4 - 12/25/2019 03:40 PM - Anonymous

- Related to deleted (Refactor #23300: Do not use string interpolation when composing SQL queries.)
